//-----------------------------------------------------------------------------
// Created on: 13 October 2013
// Created by: Sergey SLYADNEV
// Web-site: http://quaoar.su/blog
//-----------------------------------------------------------------------------

#ifndef BSpl_BasisFindSpan_HeaderFile
#define BSpl_BasisFindSpan_HeaderFile

//! Algorithm finding knot span index.
//!
//! Inputs:
//!   u  -- target knot,
//!   U  -- vector of knots,
//!   nU -- number of knots,
//!   p  -- degree.
//!
//! Outputs:
//!   index of the knot span.
class BSpl_BasisFindSpan
{
// Construction & destruction:
public:

  BSpl_BasisFindSpan();
  virtual ~BSpl_BasisFindSpan();

public:

  int operator()(const double  u,
                 const double* pU,
                 const int     nU,
                 const int     p) const;

};

#endif
