//-----------------------------------------------------------------------------
// Created on: 13 October 2015
// Created by: Sergey SLYADNEV
// Web-site: http://quaoar.su/blog
//-----------------------------------------------------------------------------

#ifndef Prim_Curve_HeaderFile
#define Prim_Curve_HeaderFile

// Aux includes
#include <Aux_SharedPtr.h>

// Prim includes
#include <Prim_XYZ.h>

//! Base class for 3D parametric curves.
class Prim_Curve : public Aux_SharedObject
{
// Construction & destruction:
public:

  Prim_Curve();
  virtual ~Prim_Curve();

public:

  virtual double
    MinParameter() const = 0;

  virtual double
    MaxParameter() const = 0;

  virtual void
    Eval(const double u,
         xyz& P) const = 0;

};

//! Convenience shortcut.
typedef Prim_Curve curve;

#endif
